<!--
  - Copyright (C) 2020-2023 The Hunter2 Contributors.
  -
  - This file is part of Hunter2.
  -
  - Hunter2 is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License as published by the Free
  - Software Foundation, either version 3 of the License, or (at your option) any later version.
  -
  - Hunter2 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
  - PARTICULAR PURPOSE.  See the GNU Affero General Public License for more details.
  -
  - You should have received a copy of the GNU Affero General Public License along with Hunter2.  If not, see <http://www.gnu.org/licenses/>.
  -->
<template>
  <span :title="title === undefined ? localeValue : title">{{ distanceToNow }}</span>
</template>
<script>
import {format, formatDistanceToNow, isFuture} from 'date-fns'

export default {
  props: {
    value: {
      required: true,
      type: String,
    },
    title: {
      default: undefined,
      type: String,
    },
  },
  computed: {
    localeValue() {
      return format(new Date(this.value), 'PPPPpppp')
    },
    distanceToNow() {
      const date = new Date(this.value)
      const [prefix, suffix] = isFuture(date) ? ['in ', ''] : ['', ' ago']
      return `${prefix}${formatDistanceToNow(date)}${suffix}`
    },
  },
}
</script>
<style lang="scss" scoped>
span {
    white-space: nowrap;
}
</style>
